--[[

Currently unnamed 'fake 3D' tank game
celynwalters


To do:
- Blocks together, don't draw hidden walls (they overlap wrongly)
- Shadows, then light effect wouldn't look so crap
- Löads of other stuff..
- Replace more commented 'o's with 'ö's :)

obey.

]]

--======================================================================--
-- Shortcuts															--
--======================================================================--
gfx = love.graphics
lfs = love.filesystem
li = love.image
keydown = love.keyboard.isDown
--======================================================================--
-- The 'Big Three' - load, update, draw									--
--======================================================================--
function love.load()
	screen_w = gfx.getWidth()
	screen_h = gfx.getHeight()
	-- Löad images
	ground = gfx.newImage("ground.png")
	block_top = gfx.newImage("block_top.png")
	block_side = gfx.newImage("block_side.png")
	tank = gfx.newImage("tank.png")
	gfx.setColorMode("combine")
	gfx.setBackgroundColor(30,30,180)
	sun_rotation = 0.1

	tile_size = 128	-- Only squares... for now....
	tile_scale = 1	-- Changes later for layers
	layer_h = 0		-- Height in  multiples of blocks, used later

	x = -1.5	-- Effectively where the camera is placed on the map, in number of blocks (negative)
	y = -1.5	-- ^^
	vanish_x = screen_w/2	-- Vanishing point is in the centre for
	vanish_y = screen_h/2	--  this game (unless I have slopes...) yeah right.

	camera_height = 8*tile_size		-- Hmm...
	camera_elevation = 0			-- Not yet implemented (maybe never)

	-- Map stuff!
	-- Any width or height can be used, because I count it later
	map = {				-- One day, the maps will be seperate file with more terrains
	{ 1, 0, 1, 0, 0, 0, 0, 0, 0},
	{ 0, 0, 0, 0, 0, 1, 1, 1, 0},
	{ 1, 0, 1, 0, 0, 1, 0, 1, 0},
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{ 0, 1, 0, 0, 0, 0, 0, 1, 0},
	{ 0, 0, 0, 1, 0, 1, 0, 0, 0},
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{ 0, 1, 0, 0, 0, 0, 0, 1, 0},
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0},
	}
	map_w = #map[1]
	map_h = #map

	player = {}				-- Not sure why I did this, might come in handy
	player.wh = 30			-- Square image size
	player.orientation = 0	-- Points up to begin with
	player.speed = 0.05

end
--------------------------------------------------------------------------
function love.update(dt)
	if keydown("up") then
		x = x - player.speed*math.sin(player.orientation)
		-- Do the collision stuff... not yet
		for v=1,map_h do
			for i=1,map_w do
				y = y + (player.speed*math.cos(player.orientation))/(map_w*map_h)
			end
		end
	end
	if keydown("down") then
		x = x + player.speed*math.sin(player.orientation)
		y = y - player.speed*math.cos(player.orientation)
	end
	if keydown("left") then
		player.orientation = player.orientation - 0.1
	end
	if keydown("right") then
		player.orientation = player.orientation + 0.1
	end
--[[ Old code, probably will never use
	if keydown("w") then
	if camera_elevation > 0 then camera_elevation = camera_elevation - 1 end
	end
	if keydown("s") then
		if camera_elevation < 90 then camera_elevation = camera_elevation + 1 end
	end
]]
	if keydown(" ") then
		sun_rotation = sun_rotation + .03
	end

	if sun_rotation >= math.pi*2 then sun_rotation = sun_rotation - math.pi*2
	elseif sun_rotation < 0 then sun_rotation = sun_rotation + math.pi*2
	end	


-- Experimental sun direction stuff, kinda works
color_ground = {128,128,128}
color_tank = {128,128,128}
color_top = {128,128,128}
color_white = {255,255,255}
color_red = {255,0,0}
color_n = {70+(math.cos(sun_rotation)+1)*40,70+(math.cos(sun_rotation)+1)*40,70+(math.cos(sun_rotation)+1)*40}
color_w = {70+(math.cos(sun_rotation+math.pi/2)+1)*40,70+(math.cos(sun_rotation+math.pi/2)+1)*40,70+(math.cos(sun_rotation+math.pi/2)+1)*40}
color_s = {70+(math.cos(sun_rotation+math.pi)+1)*40,70+(math.cos(sun_rotation+math.pi)+1)*40,70+(math.cos(sun_rotation+math.pi)+1)*40}
color_e = {70+(math.cos(sun_rotation+3*math.pi/2)+1)*40,70+(math.cos(sun_rotation+3*math.pi/2)+1)*40,70+(math.cos(sun_rotation+3*math.pi/2)+1)*40}
end
--------------------------------------------------------------------------
function love.draw()

	-- To make sure the layers are in the correct order, the drawing is seperated (see 'to do')
	-- Ground
	for v=1,map_h do
		for i=1,map_w do
			if map[v][i] == 0 then
				layer_h = 0
				tile_scale = (camera_height/(camera_height-layer_h))
				setColor(color_ground)
				gfx.draw(ground,(tile_size*x)+(tile_size*(i-1))+vanish_x,(tile_size*y)+(tile_size*(v-1))+vanish_y,0,tile_scale,tile_scale)
			end
		end
	end

	-- Sides
	for v=1,map_h do
		for i=1,map_w do
			if (-y >= v) then						-- If south of block
				if map[v][i] == 1 then
					layer_h = 128
					tile_scale = (camera_height/(camera_height-layer_h))
					draw_se(i,v)
				end
			elseif (-y <= v-1) then					-- If north of block
				if map[v][i] == 1 then
					layer_h = 128
					tile_scale = (camera_height/(camera_height-layer_h))
					draw_ne(i,v)
				end
			elseif (-x >= i) and (-y <= v) then		-- If east of block
				if map[v][i] == 1 then
					layer_h = 128
					tile_scale = (camera_height/(camera_height-layer_h))
					draw_ew(i,v)
				end
			else
				if map[v][i] == 1 then				-- If west of block
					layer_h = 128
					tile_scale = (camera_height/(camera_height-layer_h))
					draw_ws(i,v)				
				end
			end				
		end
	end

	-- Player, offset so the centre of the tank is in the centre of the screem
	setColor(color_tank)
	gfx.draw(tank,vanish_x,vanish_y,player.orientation,1,1,player.wh/2,player.wh/2)

	-- Top
	for v=1,map_h do
		for i=1,map_w do
			if map[v][i] == 1 then
				layer_h = 128
				tile_scale = (camera_height/(camera_height-layer_h))
				setColor(color_top)
				gfx.draw(block_top,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,tile_scale)
			elseif map[v][i] == 2 then
				layer_h = 128
				tile_scale = (camera_height/(camera_height-layer_h))
				setColor(color_top)
				gfx.draw(block_top,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,tile_scale)
			end
		end
	end

	-- These lines might be for collision detection at some point
	setColor(color_red)
	gfx.line(vanish_x,vanish_y,vanish_x+(math.sin(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2),vanish_y-(math.cos(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2))
	gfx.line(vanish_x,vanish_y,vanish_x-(math.sin(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2),vanish_y+(math.cos(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2))
	gfx.line(vanish_x,vanish_y,vanish_x-(math.cos(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2),vanish_y-(math.sin(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2))
	gfx.line(vanish_x,vanish_y,vanish_x+(math.cos(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2),vanish_y+(math.sin(player.orientation-math.pi/4)*(math.sqrt(2*(player.wh^2)))/2))
	-- Debug stuff...
	setColor(color_white)
	gfx.print("x: "..x,5,5)
	gfx.print("y: "..y,5,25)
	gfx.print("Sun rotation: "..math.deg(sun_rotation),5,45)

	gfx.print("Arrow keys move the player",5,85)
	gfx.print("Space rotates the sun position...",5,105)
	gfx.print("You can edit the map, currently in main.lua",5,125)
	gfx.print("Things like multiple block heights are almost there",5,145)

	-- A little cross showing the centre of the screen
--	gfx.line(vanish_x-3,vanish_y,vanish_x+3,vanish_y)
--	gfx.line(vanish_x,vanish_y-3,vanish_x,vanish_y+3)
end
--======================================================================--
-- Everything else														--
--======================================================================--
function draw_ws(i,v)	-- East side is on top, then south
			setColor(color_n)
--[[north]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,(-y-v+1)/6,0,0,(-x-i)/6,0)
			setColor(color_s)
--[[south]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v)*tile_scale)+vanish_y,0,tile_scale,(-y-v)/6,0,0,(-x-i)/6,0)
			setColor(color_e)
--[[east]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i)/6,0,0,(-y-v)/6,0)
			setColor(color_w)
--[[west]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i-1)/6,0,0,(-y-v)/6,0)
end
--------------------------------------------------------------------------
function draw_ew(i,v)	-- East side is on top, then west
			setColor(color_n)
--[[north]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,(-y-v+1)/6,0,0,(-x-i)/6,0)
			setColor(color_s)
--[[south]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v)*tile_scale)+vanish_y,0,tile_scale,(-y-v)/6,0,0,(-x-i)/6,0)
			setColor(color_w)
--[[west]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i-1)/6,0,0,(-y-v)/6,0)
			setColor(color_e)
--[[east]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i)/6,0,0,(-y-v)/6,0)
end
--------------------------------------------------------------------------
function draw_se(i,v)	-- South side is on top, then east
			setColor(color_n)
--[[north]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,(-y-v+1)/6,0,0,(-x-i)/6,0)
			setColor(color_w)
--[[west]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i-1)/6,0,0,(-y-v)/6,0)
			setColor(color_e)
--[[east]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i)/6,0,0,(-y-v)/6,0)
			setColor(color_s)
--[[south]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v)*tile_scale)+vanish_y,0,tile_scale,(-y-v)/6,0,0,(-x-i)/6,0)
end
--------------------------------------------------------------------------
function draw_ne(i,v)	-- Norh side is on top, then east
			setColor(color_s)
--[[south]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v)*tile_scale)+vanish_y,0,tile_scale,(-y-v)/6,0,0,(-x-i)/6,0)
			setColor(color_w)
--[[west]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i-1)/6,0,0,(-y-v)/6,0)
			setColor(color_e)
--[[east]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,math.pi/2,tile_scale,(x+i)/6,0,0,(-y-v)/6,0)
			setColor(color_n)
--[[north]]	gfx.draw(block_side,(tile_size*x*tile_scale)+(tile_size*(i-1)*tile_scale)+vanish_x,(tile_size*y*tile_scale)+(tile_size*(v-1)*tile_scale)+vanish_y,0,tile_scale,(-y-v+1)/6,0,0,(-x-i)/6,0)
end
--------------------------------------------------------------------------
function setColor(c)
	gfx.setColor(c[1],c[2],c[3])
end
--------------------------------------------------------------------------